[![Pam Logo](project/public/img/pam.png)](https://github.com/philippebeck/pam)

# Pam

Php Approachable Microframework

[![Codacy Badge](https://api.codacy.com/project/badge/Grade/5a23727fb6954400b6c3a38a0105089e)](https://www.codacy.com/app/philippebeck/pam?utm_source=github.com&amp;utm_medium=referral&amp;utm_content=philippebeck/pam&amp;utm_campaign=Badge_Grade)
[![Maintainability](https://api.codeclimate.com/v1/badges/6cb34d98d271777ecdb1/maintainability)](https://codeclimate.com/github/philippebeck/pam/maintainability)

## Overview

Pam is a PHP microframework based on the MVC architecture.

Pam is very easy to use & very light to implement.

The model part can be used for all CRUD actions & does not need to be overloaded for basic actions.

The View part uses the Twig template engine, so it's possible to use variables, functions, filters, etc.

The Controller part inherits the essential methods of the main controller (this includes session & cookie) & the FrontController structures the input of the application.

The sessions are managed by Pam for user connection actions & the cookies for user message actions.

Access to the database is obviously managed by the Database part, via the PDO class.

## Summary

-   [Package Manager](#package-manager)  
-   [Download](#download)  
-   [Installation](#installation)  
-   [Content](#content)  
-   [Language](#language)  
-   [Support](#support)  
-   [Open-Source](#open-source)  
-   [Documentation](#documentation)  
-   [Issues](#issues)  
-   [Pull Requests](#pull-requests)  
-   [Contributing](#contributing)  
-   [Versioning](#versioning)  
-   [Creator](#creator)  
-   [Copyright](#copyright)  

---

## Package Manager

[![Packagist Version](https://img.shields.io/packagist/v/pjs/pam.svg?label=Packagist)](https://packagist.org/packages/pjs/pam)

Composer : `composer require pjs/pam`  

---

## Download

[Latest Release](https://github.com/philippebeck/pam/releases)  

`git clone https://github.com/philippebeck/pam.git`  
  
[![Repo Size](https://img.shields.io/github/repo-size/philippebeck/pam.svg?label=Repo+Size)](https://github.com/philippebeck/pam/tree/master)

---

## Installation

How to install in 3 steps:

1.  $ composer require pjs/pam
2.  Move the content of the folder vendor/pjs/pam/project in your project root folder
3.  $ composer dump-autoload

---

## Content

The project contains 2 folders :  
-   core = the MVC source code : `Model` - `View` - `Controller`  
-   project = the Project starter : `config` - `public` `src`  

[![CSS Code Size](https://img.shields.io/github/languages/code-size/philippebeck/pam.svg?label=Code+Size)](https://github.com/philippebeck/pam/tree/master)

---

## Language

Pam is wrote with PHP

[![GitHub Top Language](https://img.shields.io/github/languages/top/philippebeck/pam.svg?label=PHP)](https://github.com/philippebeck/pam)

---

## Support

Pam has continuous support !

[![Project Maintained](https://img.shields.io/maintenance/yes/2019.svg?label=Maintained)](https://github.com/philippebeck/pam)
[![GitHub Last Commit](https://img.shields.io/github/last-commit/philippebeck/pam.svg?label=Last+Commit)](https://github.com/philippebeck/pam/commits/master)

---

## Open-Source

[![GitHub Stars](https://img.shields.io/github/stars/philippebeck/pam.svg?label=GitHub+:+Pam+|+Stars)](https://github.com/philippebeck/pam)

---

## Documentation

Documentation is available !

[![WebSite Status](https://img.shields.io/website-up-down-green-red/https/github.com/philippebeck/pam/wiki.svg?label=Documentation)](https://github.com/philippebeck/pam/wiki)

---

## Issues

Issues can be created here

[![GitHub Open Issues](https://img.shields.io/github/issues/philippebeck/pam.svg?label=Issues)](https://github.com/philippebeck/pam/issues)

---

## Pull Requests

And Pull Requests can be created there

[![GitHub Open Pull Requests](https://img.shields.io/github/issues-pr/philippebeck/pam.svg?label=Pull+Requests)](https://github.com/philippebeck/pam/pulls)

---

## Contributing

Pam needs you if you like it : sends pull requests on GitHub to improve it !!

[![GitHub Contributors](https://img.shields.io/github/contributors/philippebeck/pam.svg?label=Contributors)](https://github.com/philippebeck/pam/graphs/contributors)

---

## Versioning

Pam is maintained under the [Semantic Versioning 2.0.0](https://semver.org)

[![GitHub Version](https://img.shields.io/github/tag/philippebeck/pam.svg?label=Version)](https://github.com/philippebeck/pam/blob/master/composer.json)

---

## Creator

Philippe Beck

[![WebSite Status](https://img.shields.io/website-up-down-green-red/https/philippebeck.net.svg?label=https://philippebeck.net)](https://philippebeck.net)
[![GitHub Followers](https://img.shields.io/github/followers/philippebeck.svg?label=GitHub+:+philippebeck+|+Followers)](https://github.com/philippebeck)
[![Twitter Follow](https://badgen.net/twitter/follow/philippepjbeck)](https://twitter.com/philippepjbeck)

---

## Copyright

Code released under the MIT License

[![GitHub License](https://img.shields.io/github/license/philippebeck/pam.svg?label=License)](https://github.com/philippebeck/pam/blob/master/LICENSE)

---

## Support on Beerpay

Hey dude! Help me out for a couple of :beers:!

[![Beerpay](https://beerpay.io/philippebeck/pam/badge.svg?style=beer-square)](https://beerpay.io/philippebeck/pam)  [![Beerpay](https://beerpay.io/philippebeck/pam/make-wish.svg?style=flat-square)](https://beerpay.io/philippebeck/pam?focus=wish)
